Bug 2244 - Improve 'urpmi --auto' behavior.
: Improve 'urpmi --auto' behavior.
Status: VERIFIED FIXED
Product: Desktop Bugs
Classification: ROSA Desktop
Component: Main Packages
: Fresh
: All Linux
: Normal normal
: ---
Assigned To: ROSA Linux Bugs
: ROSA Linux Bugs
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-25 12:16 MSD by Denis Silakov
Modified: 2013-07-16 15:16 MSD (History)
2 users (show)

See Also:
RPM Package:
ISO-related:
Bad POT generating:
Upstream:
vladimir.potapov: qa_verified+
andrey.bondrov: published+


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Denis Silakov 2013-06-25 12:16:29 MSD
Currently 'urpmi --auto' works in a very straightforward way in case when you have several alternatives to satisfy some dependency - it just selects the first package from the set of possible alternatives. There are two problems with this approach:
- sometimes we have 'wrong' alternatives, when packages provide some features by mistake - e.g., we had an example with liblcms.so.2 provided by both liblcms2_2 and libreoffice-core;
- packages are ordered by their ids in internal rpm database, so 'urpmi --auto' can select different packages for the same request in different systems.

The suggestion is to try to select a package whose name is (literally) the closest one to the requested feature. More particular - select a package whose name has the largest common substring with the requested feature.

So 'urpm --auto libfoo.so' will always prefer 'libfoo' package to something else.
Comment 1 Denis Silakov 2013-06-25 12:18:58 MSD
Advisory:

Improved 'urpmi --auto' to choose a package whose name has the longest common substring with the requested feature.


Build lists:
https://abf.rosalinux.ru/build_lists/1121804
https://abf.rosalinux.ru/build_lists/1121803
Comment 2 Denis Silakov 2013-06-27 16:23:54 MSD
Brr, wrong build lists.

Correct ones:

https://abf.rosalinux.ru/build_lists/1174536
https://abf.rosalinux.ru/build_lists/1174537
Comment 3 Vladimir Potapov 2013-07-16 14:57:58 MSD
urpmi-6.71-26-rosa2012.1
****************** Advisory ***********************
Improved 'urpmi --auto' to choose a package whose name has the longest common substring with the requested feature.
***************************************************
QA Verified